<template>
  <div id="cover">
    <div id="bg"></div>
  </div>
</template>

<script>
export default {
  props: {
    coverBlur: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      bgBlurSize: 40,
    }
  },
  watch: {
    coverBlur() {
      this.changeCoverBlur();
    }
  },
  methods: {
    async hideBlur() {
      while (this.bgBlurSize > 0) {
        this.bgBlurSize -= 2;
        document.getElementById("cover").style.setProperty("--blur-size", this.bgBlurSize + "px");
        await new Promise((resolve) => {
          requestAnimationFrame(() => {
            resolve();
          });
        });
      }
    },
    changeCoverBlur() {
      let coverDom = document.getElementById("cover");

      if (!this.coverBlur) {
        coverDom.style.setProperty("--blur-size", "0px");
      } else {
        coverDom.style.setProperty("--blur-size", this.bgBlurSize + "px");
      }
    }
  },
  mounted() {
    this.changeCoverBlur();
  }
};
</script>

<style scoped>
#cover {
  --bg-height: 100vh;
  --bg-width: 100vw;
  position: absolute;
  top: calc(var(--blur-size) * -2);
  left: calc(var(--blur-size) * -2);
  height: calc(var(--bg-height) + var(--blur-size) * 4);
  width: calc(var(--bg-width) + var(--blur-size) * 4);
  filter: blur(var(--blur-size));
  background-image: url("../assets/img/bg.jpg");
  background-size: cover;
  z-index: -1;
}
#bg {
  position: absolute;
  top: calc(var(--blur-size) * 2);
  left: calc(var(--blur-size) * 2);
  height: var(--bg-height);
  width: var(--bg-width);
  background-image: url("../assets/img/bg.jpg");
  background-repeat: no-repeat;
  background-attachment: fixed;
  background-position: center;
  background-size: cover;
  z-index: 0;
}
</style>